# -*- coding:utf-8 -*-
from __future__ import division 
from Tkinter import *
import numpy as np
from scipy import signal as sg
import pyaudio
import Variabeln as vars
import pygame
import pygame.midi
from pygame.locals import *

p = pyaudio.PyAudio()

def play(gen):
		'''Startet den Tongenerator und die Audioausgabe'''
		
		def callback(in_data, frame_count, time_info, status):
			
			data = (32767*gen.generate(frame_count/24000)).astype(np.int16)
			return (data.copy(), pyaudio.paContinue)
		
			
		global outStream

		outStream = p.open(format=pyaudio.paInt16,channels=1,\
				rate=24000,output=True,frames_per_buffer=vars.CHUNK,stream_callback=callback)
				
master=Tk()

class Generator(object):
	'''Tongenerator Basisklasse'''
	
		
	def generate(self,T):
		'''Erzeugt neue Daten für einen Klang der 
		Dauer T[s]. Merkt sich den Zustand und erzeugt
		beim nächsten Aufruf den Klang, der den nächsten T[s]
		entspricht.'''
		raise NotImplementedError() 

class zombie_resonanz_generator:
	def __init__(self,ton=0,array={}):
		self.ton=ton
		self.array=array
		self.death_timer=1
		self.sound=0
		self.counter=1
		self.timer=0 # der timer bestimmt die hüll kurve diese wird in jedem genrator benötigt 
		self.steigungswinkel=0
		
	def generate(self,T):			
		self.timer=np.arange(int(T*vars.RATE*(self.counter-1)),int(T*vars.RATE*self.counter))
		if self.death_timer!= 0:
				
			if self.counter==1:
				self.RELEASE=vars.ATTACK*(self.death_timer) 
				self.steigungswinkel=((-self.death_timer)/self.RELEASE)
			if self.counter<=(int(self.RELEASE*int(vars.RATE/vars.CHUNK))):
				self.timer=self.death_timer+((self.timer/vars.RATE)*self.steigungswinkel)
				if self.counter==(int(self.RELEASE*int(vars.RATE/vars.CHUNK))): 
					ver.DEL_spur_zombie(self.ton)
				else:
					self.counter+=1	
			
			for i in self.array:
				xx=np.arange(int(vars.RATE*T))*(2*np.pi*i)/vars.RATE+self.array[i][1]*np.ones(int(T*vars.RATE))
				self.array[i][1]+=(2*np.pi*i)*T
				xx=np.sin(xx)*self.array[i][0]
				self.sound+=xx.copy()
		
		return np.multiply(self.sound,self.timer)
			
class resonanz_generator(Generator):
	def __init__(self,ton=0,freq=0):
		self.ton=ton
		self.freq=freq
		self.resonanzfaktor=0.25
		self.grenzwert=0.001		
		self.array={}
		self.previus={}
		self.sound=0
		self.status=0
		self.counter=1
		self.max_Amplitude=vars.Max_amplitude
		self.steigungswinkel=0
		self.timer=np.ones(vars.CHUNK)
		self.bestimmung_der_neben_frequenzen()
		self.filter_nebenfrequenzen()
		
	def generate(self,T): 
		'''erszeugt ein array mit "resonaz" allerdings wurden dabei viele variablen liegen gelassen, es gibt 
		also defentif möglich keiten diese art der generation von Tönen weiter aus zu bauen, jedoch ist mein computer 
		zu schwach für eine bessere variante'''
		for i in self.array:
			xx=np.arange(int(vars.RATE*T))*(2*np.pi*i)/vars.RATE+self.array[i][1]*np.ones(int(T*vars.RATE))
			self.array[i][1]+=(2*np.pi*i)*T
			xx=np.sin(xx)*self.array[i][0]
			self.sound+=xx.copy()
		
		if self.status==1 or self.status==0:
			self.timer=np.arange(int(T*vars.RATE*(self.counter-1)),int(T*vars.RATE*self.counter))
			
		"""init form der ton klang kurve"""
		if self.status==0:#ATTACK
			if self.counter==1:
				self.steigungswinkel=(self.max_Amplitude/vars.ATTACK)
			if self.counter<=(int(vars.ATTACK*int(vars.RATE/vars.CHUNK))):
				self.timer=((self.timer/vars.RATE)*self.steigungswinkel)
				if self.counter==(int(vars.ATTACK*int(vars.RATE/vars.CHUNK))):
					self.DECLINE=vars.ATTACK*(self.max_Amplitude-(self.max_Amplitude*0.7))
					
					self.counter=1
					self.status=1
					
				else: 
 					self.counter+=1
			
		elif self.status==1:#DECLINE
			if self.counter==1 :
				self.steigungswinkel=(((self.max_Amplitude*0.7)-self.max_Amplitude)/self.DECLINE) 
			if self.counter<=(int(self.DECLINE*int(vars.RATE/vars.CHUNK))):
				self.timer=self.max_Amplitude+((self.timer/vars.RATE)*self.steigungswinkel)    
				if self.counter==(int(self.DECLINE*int(vars.RATE/vars.CHUNK))):
					self.counter=1  
					self.status=2

				else: 
					self.counter+=1
			
		elif self.status==2:#SUSTAIN	
			self.timer=np.ones(int(T*vars.RATE))*(self.max_Amplitude*0.7)
		
		return np.multiply(self.sound,self.timer)

		
	def bestimmung_der_neben_frequenzen(self):
		"""eigentliches herz der resonanz, ist aber nicht sehr akurat und er skizziert """
		self.array.update({self.freq:[1,0,True]})
		for i in range(int(np.log(self.grenzwert)/np.log(self.resonanzfaktor))):
			copy=self.array.copy()
			 
			for i in copy.copy():
				if self.array[i][0]*self.resonanzfaktor<=self.grenzwert:
					self.array[i][2]=False
					pass
				else:
					if self.array[i][2]:
						x=i*2
						if x in self.array:
							self.array[x][0]+=self.array[i][0]*self.resonanzfaktor
							self.array[x][2]=True
						else:
							self.array.update({x:[self.array[i][0]*self.resonanzfaktor,0,True]})
						y=i/2
						if y in self.array:
							self.array[y][0]+=self.array[i][0]*self.resonanzfaktor
							self.array[y][2]=True
						else:
							self.array.update({y:[self.array[i][0]*self.resonanzfaktor,0,True]})
						self.array[i][2]=False
					else:
						pass
						
	def filter_nebenfrequenzen(self):
		merk=0
		for i in self.array.copy():
			if i<=20 or i>=20000:
				del self.array[i]
			else:
				merk+=self.array[i][0]			
		for i in self.array:
			self.array[i][0]/=merk
		
class TwoXZombie_generator_sinus(Generator):
	def __init__(self,ton=0,freq=0,counter=1,timer=0,phaseshift=0.0,death_timer=0,phaseshift_M=0,steigungswinkel=0,RELEASE=1):
		self.ton=ton
		self.freq=freq
		self.phaseshift=phaseshift
		self.phaseshift_M=phaseshift_M
		self.counter=counter
		self.death_timer=death_timer
		self.steigungswinkel=steigungswinkel
		self.RELEASE=RELEASE
		self.timer=timer
		self.delete=False
	def generate(self,T):
		self.timer=np.arange(int(T*vars.RATE*(self.counter-1)),int(T*vars.RATE*self.counter))
		if self.delete:
			ver.DEL_spur_zombie(self.ton)
		
		if self.death_timer!=0: 
		
			if self.counter==1:

				self.RELEASE=vars.ATTACK*(self.death_timer) 
				self.steigungswinkel=((-self.death_timer)/self.RELEASE)
			if self.counter<=(int(self.RELEASE*int(vars.RATE/vars.CHUNK))):
				self.timer=self.death_timer+((self.timer/vars.RATE)*self.steigungswinkel)
				if self.counter==(int(self.RELEASE*int(vars.RATE/vars.CHUNK))): 

					self.delete=True

				else:
					self.counter+=1	

			xx = np.arange(int(T*vars.RATE))*(2*np.pi*vars.FREQ_M)/vars.RATE + self.phaseshift_M*np.ones(int(vars.RATE*T))
			self.phaseshift_M+=2*np.pi*vars.FREQ_M*T
			
			if vars.TYP_M==1:
				xx=np.sin(xx)
			elif vars.TYP_M==2:
				xx=sg.sawtooth(xx)
			elif vars.TYP_M==3:
				xx=sg.square(xx, duty = 0.8)
				
			yy=np.arange(int(T*vars.RATE))*(2*np.pi*self.freq)/vars.RATE\
				+self.phaseshift*np.ones(int(T*vars.RATE))
			self.phaseshift+=T*2*np.pi*self.freq
			
			yy+=vars.BETA*xx
			
			if vars.TYP==1:
				yy=np.sin(yy)
			elif vars.TYP==2:
				yy=sg.sawtooth(yy)
			elif vars.TYP==3:
				yy=sg.square(yy, duty = 0.8)
				
		yy=np.multiply(yy,self.timer)
 
		return yy.copy()

class TwoXSinusGenerator(Generator):
	'''Sinus-Tongenerator'''
	
	def __init__(self,freq=0,counter=1,timer=0,status=0 ,steigungswinkel=0,max_Amplitude=vars.Max_amplitude,phaseshift_M=0.0 ,DECLINE=0):
		
		self.freq=freq
		self.phaseshift=0.0
		self.phaseshift_M=phaseshift_M
		self.counter=counter
		self.timer=timer 
		self.status=status
		self.steigungswinkel=steigungswinkel
		self.max_Amplitude=max_Amplitude
		self.DECLINE=DECLINE
		
		
	def first_phaseshift(self):
		self.phaseshift=np.random.randint(0,10000)
		
		
	def generate(self,T):
		'''Erzeugt einen Sinusklang der Dauer T.
		Damit Stücke ohne Knacksen verbunden werden,
		können, merkt sich die Funktion die Phasenverschiebung
		am Ende des letzten Stücks''' 
		if self.counter==1 and self.status==0:
			self.first_phaseshift()

		xx = np.arange(int(T*vars.RATE))*(2*np.pi*vars.FREQ_M)/vars.RATE + self.phaseshift_M*np.ones(int(vars.RATE*T))
		self.phaseshift_M+=2*np.pi*vars.FREQ_M*T
		if vars.TYP_M==1:
			xx=np.sin(xx)
		elif vars.TYP_M==2:
			xx=sg.sawtooth(xx)
		elif vars.TYP_M==3:
			xx=sg.square(xx, duty = 0.8)

		 
		yy=np.arange(int(T*vars.RATE))*(2*np.pi*self.freq)/vars.RATE\
			+self.phaseshift*np.ones(int(T*vars.RATE))
		self.phaseshift+=T*2*np.pi*self.freq
		
		yy+=vars.BETA*xx
		
		if vars.TYP==1:
			yy=np.sin(yy)
		elif vars.TYP==2:
			yy=sg.sawtooth(yy)
		elif vars.TYP==3:
			yy=sg.square(yy, duty = 0.8)

		'''timer für ton Hull kurve'''
		if self.status==1 or self.status==0:			
			self.timer=np.arange(int(T*vars.RATE*(self.counter-1)),int(T*vars.RATE*self.counter))
		"""form der ton Hull kurve"""
		if self.status==0:#ATTACK
			if self.counter==1:
				self.steigungswinkel=(self.max_Amplitude/vars.ATTACK)
			if self.counter<=(int(vars.ATTACK*int(vars.RATE/vars.CHUNK))):
				self.timer=((self.timer/vars.RATE)*self.steigungswinkel)
				if self.counter==(int(vars.ATTACK*int(vars.RATE/vars.CHUNK))):
					self.DECLINE=vars.ATTACK*(self.max_Amplitude-(self.max_Amplitude*0.7))
					
					self.counter=1
					self.status=1
					
				else: 
 					self.counter+=1
			
		elif self.status==1:#DECLINE
			if self.counter==1 :
				self.steigungswinkel=(((self.max_Amplitude*0.7)-self.max_Amplitude)/self.DECLINE) 
			if self.counter<=(int(self.DECLINE*int(vars.RATE/vars.CHUNK))):
				self.timer=self.max_Amplitude+((self.timer/vars.RATE)*self.steigungswinkel)     
				if self.counter==(int(self.DECLINE*int(vars.RATE/vars.CHUNK))):
					self.counter=1
					self.status=2
				else: 
					self.counter+=1
			
		elif self.status==2:#SUSTAIN	
			self.timer=np.ones(int(T*vars.RATE))*(self.max_Amplitude*0.7)

		yy=np.multiply(yy,self.timer)

		return yy.copy()

class Kompressor:
	def __init__(self,threshold=0.65,ratio=20 ,Attack_timer=1,Release_timer=1,make_up_gain=0,knee_width=0.2 ,previous_output=np.zeros(vars.CHUNK),Attack_counter=0): 
		self.threshold=threshold
		self.ratio=ratio
		self.Attack_timer=Attack_timer
		self.Release_timer=Release_timer
		self.make_up_gain=make_up_gain
		self.knee_width=knee_width
		self.previous_output=previous_output
		self.Pegel_faktor = np.ones(vars.CHUNK)
		self.alpha = 0.05/vars.CHUNK
		self.Attack_counter=Attack_counter
		self.ATTACK=False
		self.pegel_nach_kompressor_delay=0
	def compress(self,pegel,signal):
		'''main für den kompressor'''
		pegel_start=pegel
		pegel_nach_kompressor= self.Reduktion(pegel) 
		neuer_faktor = np.where(pegel_start>0, np.divide(pegel_nach_kompressor,pegel_start),1)
		self.Pegel_faktor=self.level_detection(neuer_faktor)
		self.pegel_nach_kompressor_delay=pegel_nach_kompressor
		signal=np.multiply(signal,self.Pegel_faktor)	
		return signal		 

			
			
	
	def check_for_threshhold(self,pegel):
		'''return True if the signal has any element that is bigger than the threshold'''
		try:
			for  i in pegel:
				if 2*(i-self.threshold) < -self.knee_width:
					return True
				else:
					pass 
			return False
		except TypeError:
			print "Type Error"
			return False
			
	def Reduktion(self,pegel):
		'''tatsächlich kompression der töne'''
		pegel = pegel.copy()
		for index, i in enumerate(pegel): #no kompression
			if 2*(i-self.threshold) < -self.knee_width:
				i=i+self.make_up_gain
				
			elif 2*(i-self.threshold)<= self.knee_width: # Softknee
				i=i+(1/self.ratio-1)*((i-self.threshold)+(self.knee_width/2))**2/(2*self.knee_width)+self.make_up_gain
				
			elif 2*(i-self.threshold)> self.knee_width: # Hardknee
				i=self.threshold+((i-self.threshold)/self.ratio)+self.make_up_gain
				
			pegel[index] = i
		return pegel
	  
	def level_detection(self,pegel):   
		"""ist ein filter der die geschwindigkeit mit der, der Kompressor eingreift veringert wird"""
		for index, i in enumerate(pegel):
			
			if index == 0: #nimmt sample aus vorherigen CHUNK
				i=((1-(self.alpha*self.Attack_timer))*self.Pegel_faktor[vars.CHUNK-1])+((self.alpha*self.Attack_timer)*i)
			else:
				i= (1-(self.alpha*self.Attack_timer))*pegel[index-1]+((self.alpha*self.Attack_timer)*i)				
			pegel[index]=i
		return pegel
		
	def check_for_runners(self,signal):
		'''wenn irgend ein wert im signal nach der kompression immer noch ueber 1 ist die rückgabe True'''
		#das ist eigentlich nur zur probe gewesen
		for index, i in enumerate(signal):
			if i>=1:
				return True 
			elif i==0:
				return True
			else:
				continue
		return False	

class Zombie_generator_sinus(Generator):
	def __init__(self,ton=0,freq=0,counter=1,timer=0,phaseshift=0.0,death_timer=0,steigungswinkel=0,RELEASE=1):
		self.ton=ton
		self.freq=freq
		self.phaseshift=phaseshift
		self.counter=counter
		self.death_timer=death_timer
		self.steigungswinkel=steigungswinkel
		self.RELEASE=RELEASE
		self.timer=timer
		self.delete=False
	def generate(self,T):	
		self.timer=np.arange(int(T*vars.RATE*(self.counter-1)),int(T*vars.RATE*self.counter))
		if self.delete:
			ver.DEL_spur_zombie(self.ton)
		
		if self.death_timer!=0: 
			if self.counter==1:
				self.RELEASE=vars.ATTACK*(self.death_timer) 
				self.steigungswinkel=((-self.death_timer)/self.RELEASE)
			if self.counter<=(int(self.RELEASE*int(vars.RATE/vars.CHUNK))):
				self.timer=self.death_timer+((self.timer/vars.RATE)*self.steigungswinkel)
				if self.counter==(int(self.RELEASE*int(vars.RATE/vars.CHUNK))): 
					self.delete=True
				else:
					self.counter+=1	

			yy=np.arange(int(T*vars.RATE))*(2*np.pi*self.freq)/vars.RATE\
				+self.phaseshift*np.ones(int(T*vars.RATE))
			self.phaseshift+=T*2*np.pi*self.freq
		
		if vars.TYP==1:				
			yy=(np.sin(yy))
		elif vars.TYP==2:
			yy=(sg.sawtooth(yy))
		elif vars.TYP==3:
			yy=(sg.square(yy, duty = 0.8))
		yy=np.multiply(yy,self.timer)

		return yy.copy()
		
class Delay_Generator(Generator):
	def __init__(self,array=0,timestamp=0,timer_merk=0):
		self.counter=0
		self.status=0
		self.array=array
		self.timestamp=timestamp
		self.delay_wert=0.5
		self.delay_timer=0.4
		self.timer=0
		self.timer_merk=timer_merk
	def generate(self,T):
		'''für das erschaffen eines dealy, wird jewiels ein signal-array und ein peggel-array,
		ein gespeichert und nach einer vom nutzer bestimten Zeit and die Ausgabe dran gehängt'''
		
		if self.status==0:
			self.counter+=1
			
			if self.counter==int(self.delay_timer*int(vars.RATE/vars.CHUNK)):
				self.status=1
				self.counter=0
				
			return np.zeros(int(T*vars.RATE))#
		elif self.status==2:
			ver.DEL_Delay(self.timestamp)
			return np.zeros(int(T*vars.RATE))
		
		else:
			self.status=2
			self.timer=self.timer_merk*self.delay_wert
			return self.array*self.delay_wert
			
class SinusGenerator(Generator):
	'''Sinus-Tongenerator'''
	
	def __init__(self,freq=0,counter=1,timer=0,status=0 ,steigungswinkel=0,max_Amplitude=0.3 ,DECLINE=0):
		
		self.freq=freq
		self.phaseshift=0.0
		self.counter=counter
		self.timer=timer  #für delete funktion abklingen wichtig 
		self.status=status
		self.steigungswinkel=steigungswinkel
		self.max_Amplitude=max_Amplitude
		self.DECLINE=DECLINE
		
		
	def first_phaseshift(self):
		self.phaseshift=np.random.randint(0,10000)
		
		
	def generate(self,T):
		'''Erzeugt einen Sinusklang der Dauer T.
		Damit Stücke ohne Knacksen verbunden werden,
		können, merkt sich die Funktion die Phasenverschiebung
		am Ende des letzten Stücks''' 
		if self.counter==1 and self.status==0:
			self.first_phaseshift()
		yy=np.arange(int(T*vars.RATE))*(2*np.pi*self.freq)/vars.RATE\
			+self.phaseshift*np.ones(int(T*vars.RATE))
		self.phaseshift+=T*2*np.pi*self.freq
		
		'''init timer für ton klang kurve'''
		if self.status==1 or self.status==0:
			
			self.timer=np.arange(int(T*vars.RATE*(self.counter-1)),int(T*vars.RATE*self.counter))
		"""init form der ton klang kurve"""
		if self.status==0:#ATTACK
			if self.counter==1:
				self.steigungswinkel=(self.max_Amplitude/vars.ATTACK)
			if self.counter<=(int(vars.ATTACK*int(vars.RATE/vars.CHUNK))):
				self.timer=((self.timer/vars.RATE)*self.steigungswinkel)
				#print (self.timer)
				if self.counter==(int(vars.ATTACK*int(vars.RATE/vars.CHUNK))):
					self.DECLINE=vars.ATTACK*(self.max_Amplitude-(self.max_Amplitude*0.7))
					
					self.counter=1
					self.status=1
					
				else: 
 					self.counter+=1
			
		elif self.status==1:#DECLINE
			if self.counter==1 :
				self.steigungswinkel=(((self.max_Amplitude*0.7)-self.max_Amplitude)/self.DECLINE) 
			if self.counter<=(int(self.DECLINE*int(vars.RATE/vars.CHUNK))):
				self.timer=self.max_Amplitude+((self.timer/vars.RATE)*self.steigungswinkel)     
				#print (self.timer)
				if self.counter==(int(self.DECLINE*int(vars.RATE/vars.CHUNK))):
					self.counter=1 #bei eins starten 
					self.status=2

				else: 
					self.counter+=1
			
		elif self.status==2:#SUSTAIN	
			self.timer=np.ones(int(T*vars.RATE))*(self.max_Amplitude*0.7)
			#print (self.timer)
		'''Wellen-typ bestimmung'''
		if vars.TYP==1:				
			yy=(np.sin(yy))
		elif vars.TYP==2:
			yy=(sg.sawtooth(yy))
		elif vars.TYP==3:
			yy=(sg.square(yy, duty = 0.8))

		yy=np.multiply(yy,self.timer)

		return yy.copy()

class Input_midi_keyboard:
	def __init__(self,oktave=0):
 		pygame.init()
		pygame.fastevent.init()
		self.event_get=pygame.fastevent.get
		self.event_post = pygame.fastevent.post
		self.oktave=oktave
		pygame.midi.init()
		pygame.display.set_mode((1,1))
		self.device_id=None
		self.input_var=pygame.midi.Input( self.organisiere() )
		
	def organisiere(self):
		"""bestimmt input id für python-midi"""
		if self.device_id is None:
			input_id = pygame.midi.get_default_input_id()
		else:
			input_id = self.device_id
		return 	input_id
	
	def generate_tasten(self):
		"""liefert midi input"""
		
		events = self.event_get()
		
		for e in events:
			if e.type in [pygame.midi.MIDIIN]:
				ton=e.data1
				if e.status==144:#ton objekt init
					ver.generiere_spur_key(ton)	
				elif e.status==128:#delete-funktion
					try:
						ver.generiere_zombie_spur(ton)
						ver.DEL_spur(ton)
					except KeyError:
						pass  
					

		if self.input_var.poll():
			midi_events = self.input_var.read(10)
			# convert them into pygame events.
			midi_evs = pygame.midi.midis2events(midi_events, self.input_var.device_id)

			for m_e in midi_evs:
				self.event_post( m_e )		

class eine_Spur: 
	
	def __init__(self,ton=1):
		self.ton=ton
		self.init_sinus=self.generator_auswahl()
		self.get_frequenz(None)
		if vars.generator_typ==3:
			self.init_sinus.bestimmung_der_neben_frequenzen()
			self.init_sinus.filter_nebenfrequenzen()
			
	def generator_auswahl(self):
		if vars.generator_typ==1:
			return SinusGenerator(self.ton)
		elif vars.generator_typ==2:
			return TwoXSinusGenerator(self.ton)
		elif vars.generator_typ==3:
			return resonanz_generator(self.ton)
		
		
	def get_frequenz(self,dummy):
		"""frequenz uebergabe an den sinus generator"""
		def frequenz(n):
			'''berechnet die frequenz'''
			if n==0:
				return (27.5)*2**(1/6)	
				#der faktor 2**(1/6) ist leider keyboard spetzifisch 
				#die start frequen von 27.5 Hz ist nicht nötig, 
				#man kann auch bei einem höheren ton anfangen
			else:
				return 2**(1/12)*frequenz(n-1)
				
		self.init_sinus.freq=(frequenz(self.ton))	

class eine_zombie_spur: 

	def __init__(self,ton=1):
		self.ton=ton
		self.init_sinus=self.generator_auswahl()#Zombie_generator_sinus(self.ton)
		self.get_frequenz()
		
	def generator_auswahl(self):
		"""ist nur so lang nötig wie ich es nicht möglich mache von einem belibigen generator
		jede möglich sound generation möglich zu machen"""
		if vars.generator_typ==1:
			return Zombie_generator_sinus(self.ton)
		elif vars.generator_typ==2:
			return TwoXZombie_generator_sinus(self.ton)
		elif vars.generator_typ==3:
			return zombie_resonanz_generator(self.ton)
			
	def	get_living_vars(self,index):
		"""über gibt die die daten vom gelöschten generator an seinen 'zombie' partner """
		self.init_sinus.death_timer=ver.spuren[index].init_sinus.timer[63]
		if vars.generator_typ<=2:
			self.init_sinus.phaseshift=ver.spuren[index].init_sinus.phaseshift
			if vars.generator_typ==2:
				self.init_sinus.phaseshift_M=ver.spuren[index].init_sinus.phaseshift_M
		else:
			self.init_sinus.array=ver.spuren[index].init_sinus.array
			
	def get_frequenz(self):
		"""frequenz uebergabe an den sinus generator"""
		def frequenz_keyboard(n):
			if n==0:
				return 27.5*2**(1/6)
			else:
				return 2**(1/12)*frequenz_keyboard(n-1)		
		self.get_living_vars(self.ton)
		self.init_sinus.freq=(frequenz_keyboard(self.ton))	
			
class Kompresor_GUI:
	def __init__(self):
		top=Toplevel()
		top.title=("Kompressor")
		#Threshold
		Label(top,text="threshold").grid(column=0,row=0)
		self.threshold_entry=Entry(top)
		self.threshold_entry.grid(column=0,row=1)
		Button(top,text="login value",command=self.threshold_get).grid(column=1,row=1)
		#Ratio
		Label(top,text="ratio").grid(column=0,row=2)
		self.ratio_entry=Entry(top)
		self.ratio_entry.grid(column=0,row=3)
		Button(top,text="login value",command=self.ratio_get).grid(column=1,row=3)
		#Knee width
		Label(top,text="knee width").grid(column=0,row=4)
		self.knee_width_entry=Entry(top)
		self.knee_width_entry.grid(column=0,row=5)
		Button(top,text="login_value",command=self.knee_width_get).grid(column=1,row=5)
		#Make up Gain
		Label(top,text="make up gain").grid(column=0,row=6)
		self.make_up_gain_entry=Entry(top)
		self.make_up_gain_entry.grid(column=0,row=7)
		Button(top,text="login_value",command=self.make_up_gain_get).grid(column=1,row=7) 
		#genereller stuff
		Button(top,text="help",command=self.open_help_kompressor).grid(row=1,column=100)
		Button(top,text="quit kompressor",command=top.destroy).grid(row=0,column=100)
	
	def threshold_get(self): # entry
		try:
			if (float(self.threshold_entry.get())<=1.0 and float(self.threshold_entry.get())>=0.0):
				ver.komp.threshold=float(self.threshold_entry.get())
			else:
				self.Fehlermeldung()
		except ValueError:
			self.Fehlermeldung()
		 
	def ratio_get(self): # entry
		try:
			if (float(self.ratio_entry.get())>=1.0):
				ver.komp.ratio=float(self.ratio_entry.get())
			else:
				self.Fehlermeldung()
		except ValueError:
			self.Fehlermeldung()
		
	def knee_width_get(self): # entry
		try:
			if (float(self.knee_width_entry.get())<=1.0 and float(self.knee_width_entry.get())>=0.0):
				ver.komp.knee_width=float(self.knee_width_entry.get())
			else:
				self.Fehlermeldung()
		except ValueError:
			self.Fehlermeldung()
		return 0
	
	def make_up_gain_get(self): #entry  immer noch nicht zugänglich gemacht                 ##########################################
		try:
			if (float(self.make_up_gain_entry.get())<=1.0 and float(self.make_up_gain_entry.get())>=0.0):
				ver.komp.make_up_gain=float(self.make_up_gain_entry.get())
			else:
				self.Fehlermeldung()
		except ValueError:
			self.Fehlermeldung()
		return 0
	
	def Attack_timer_get(self): # entry
		try:
			if (float(self.Attack_timer_entry.get())<=1.0 and float(self.Attack_timer_entry.get())>=0.0):
				ver.komp.Attack_timer=float(self.Attack_timer_entry.get())
			else:
				self.Fehlermeldung()
		except ValueError:
			self.Fehlermeldung()
		return 0
	def open_help_kompressor(): # Button
		return 0
		
	def Fehlermeldung(self):
		tip=Toplevel()
		tip.title("ERROR")
		msg= Message(tip,text="invalid value")
		msg.pack()
		Button(tip,text="Dismiss",command=tip.destroy).pack()
		
class Soundsynthese_GUI:
	def __init__(self):
		top=Toplevel()
		Label(top,text="Pitch").grid(column=1,row=0)
		self.Pitch=Scale(top,from_=0, to=500,command=self.get_pitch)# if zero no modulation takes place  is the peitch faktor
		self.Pitch.grid(column=1,row=1)
		Label(top,text="Modulations freq").grid(column=2,row=0)
		self.Frequenz_modulation_wave=Scale(top,from_=0,to=80,command=self.get_Frequenz_modulations_wave)
		self.Frequenz_modulation_wave.grid(column=2,row=1)
		
		# für die "Modulations WAVE"
		Label(top,text="WAVE form Modulation-Wave" ).grid(column=3,row=1)
		Button(top,text="sin_M",command=self.type_sin_M).grid(column=3,row=3)
		Button(top,text="saw_M",command=self.type_saw_M).grid(column=3,row=4)
		Button(top,text="squa_M",command=self.type_squ_M).grid(column=3,row=5)
		
		#für die "Grund WAVE"
		Label(top,text="WAVE form grund wave").grid(column=0,row=2)
		Button(top,text="sin",command=self.type_sin).grid(column=0,row=3)
		Button(top,text="saw",command=self.type_saw).grid(column=0,row=4)
		Button(top,text="squa",command=self.type_squ).grid(column=0,row=5)
		
		"insgesammt maximale lautsärke für eine spur"
		Label(top,text="Max amplitude").grid(column=0,row=0)
		self.Max_amplitude=Scale(top,from_=0,to=100,command=self.empty)
		self.Max_amplitude.grid(column=0,row=1)
		
		Button(top,text="quit soundsythese",command=top.destroy).grid(column=100,row=100)
		
	def empty(self,dummy):
		pass
	
	def get_frequenz(self,x):
		if x==0:
			return 55
		else:
			return 2**(1/12)*self.get_frequenz(x-1)
			
	def get_pitch(self,dummy):
		x=self.Pitch.get()
		vars.BETA = x/100
		
	def get_Frequenz_modulations_wave(self,dummy):
		x=self.Frequenz_modulation_wave.get()
		vars.FREQ_M=self.get_frequenz(x)
		
	def get_maxamplitude(self,dummy):
		x=(self.Max_amplitude.get())/100
		vars.Max_amplitude=x
	
	def get_pitch(self,dummy):
		x=self.Pitch.get()
 		vars.BETA=(x/100)
	def type_sin(self): 
		'''gibt and das sin-wave fuer den generator genutz werden soll'''
		vars.TYP = 1
	def type_saw(self):
		'''gibt and das sawtooth-wave fuer den generator genutz werden soll'''
		vars.TYP = 2
	def type_squ(self):
		'''gibt and das square-wave fuer den generator genutz werden soll'''
		vars.TYP = 3
	def type_sin_M(self): 
		'''gibt and das sin-wave fuer den generator genutz werden soll'''
		vars.TYP_M = 1
	def type_saw_M(self):
		'''gibt and das sawtooth-wave fuer den generator genutz werden soll'''
		vars.TYP_M = 2
	def type_squ_M(self):
		'''gibt and das square-wave fuer den generator genutz werden soll'''
		vars.TYP_M = 3	
		
class GUI:
	def __init__(self):	
		Label(master,text="Lautstaerke",padx=5,pady=5).grid(row=1,column=4,columnspan=4)
		self.Amplitude = Scale(master,from_=0,to=100, length=200, tickinterval=10, orient=HORIZONTAL,command=self.Volume)
		self.Amplitude.grid(row=2,column=4,columnspan=4)  

		#Buttons grunlegedne funktinen
		Button(master, text="Mute", command = self.mute).grid(row=3,column=5) 
		Button(master, text="QUIT", command = master.quit).grid(row=3, column=6)  
		# open othere windows
		Button(master,text="open_kompressor",command=(self.open_kompressor)).grid(row=100,column=100)
		Button(master,text="open_soundsynthese",command=(self.open_soundsynthese)).grid(row=99,column=100)
	
	
	def Volume(self,x):
		'''changes Volume with slider'''
		y = self.Amplitude.get()
		vars.LAUTSTAERKE=(y/100)	
	def mute(self):
		'''setzt das Volumen auf 0'''
		self.Amplitude.set(0)
	def type_sin(self): 
		'''gibt and das sin-wave fuer den generator genutz werden soll'''
		vars.TYP = 1
	def type_saw(self):
		'''gibt and das sawtooth-wave fuer den generator genutz werden soll'''
		vars.TYP = 2
	def type_squ(self):
		'''gibt and das square-wave fuer den generator genutz werden soll'''
		vars.TYP = 3
	def open_kompressor(self):
		kmp_gui=Kompresor_GUI()
	def open_soundsynthese(self):
		syt_gui=Soundsynthese_GUI()
		
class Verwaltung(Generator):
	
	def __init__(self,synth_Ausgabe=[],spuren={},zombie_spuren={},delay_spuren={},timestamp=0):
		self.synth_Ausgabe = synth_Ausgabe 
		self.spuren = spuren
		self.zombie_spuren=zombie_spuren
		self.komp=Kompressor()
		self.timestamp=timestamp
		self.delay_spuren=delay_spuren
		
	def generate_delay_spur(self,array,timestamp,pegel):
		"""generiert ein delay generator und fügt ihn zu den delay spuren hinzu """
		open_new=Delay_Generator(array,timestamp,pegel)
		self.delay_spuren.update({timestamp:open_new})
		
	def generiere_zombie_spur(self,ton):
		"""siehe: generiere_spur_key(key für keyboard)"""
		open_new=eine_zombie_spur(ton)
		self.zombie_spuren.update({ton:open_new})
		 
	def generiere_spur_key(self,ton):
		"""generiert spur mit self.ton als index(key) in der liste spuren """
		open_new = eine_Spur(ton)  
		self.spuren.update({ton:open_new})
	def DEL_Delay(self,index):
		"""löscht automatisch alle Delay-Spuren nach der Nutzung"""
		del self.delay_spuren[index]
	
	def DEL_spur(self,index):
		"""schließt eine spur über ein gegebenen index(self.ton)"""
		del self.spuren[index]
	
	def DEL_spur_zombie(self,index):
		"""siehe DEL_spur"""
		del self.zombie_spuren[index]
 				
	def generate(self,T):
		"""gibt output, aus den generatoren, an play pyaudio weiter"""
		imk.generate_tasten()
		self.synth_Ausgabe=[]
		signal=0
		pegel=0
		vars.aktive_CHANNELS=len(self.spuren)+len(self.zombie_spuren)
		#generatoren erzeugen signal und pegel
		for i in self.spuren:	 
			self.synth_Ausgabe.append(self.spuren[i].init_sinus)
			
		for i in self.zombie_spuren:
			self.synth_Ausgabe.append(self.zombie_spuren[i].init_sinus)
		
		for i in self.delay_spuren:
			self.synth_Ausgabe.append(self.delay_spuren[i])
			
		for ge in self.synth_Ausgabe:
			signal+=(ge.generate(T))
			pegel+=(ge.timer)
			 
		self.timestamp+=1
		if isinstance(signal,int) or isinstance(pegel,int):
			return self.komp.compress(np.zeros(int(T*vars.RATE)),np.zeros(int(T*vars.RATE)))
		else: 
			signal*=vars.LAUTSTAERKE
			if vars.Echo: # delay
				self.generate_delay_spur(signal,self.timestamp,pegel*vars.LAUTSTAERKE)
			signal=self.komp.compress(pegel*vars.LAUTSTAERKE,signal)
	 		return signal
 
imk=Input_midi_keyboard() 
ver=Verwaltung() 
interfaze=GUI() 

if __name__ == "__main__":
	 play(ver)
mainloop() #doppeltes callback  
